local T, C, L, _ = unpack(select(2, ...))
if C.chat.enable ~= true then return end

local UnitPopupButtonsExtra = {
    ["ARMORY"] = { enUS ="Armory",          zhCN = "英雄榜",   zhTW = "英雄榜" },
    ["SEND_WHO"] = { enUS ="Query Detail",  zhCN = "查询玩家", zhTW = "查詢玩家" },
    ["NAME_COPY"] = { enUS ="Get Name",     zhCN = "获取名字", zhTW = "獲取名字" },
    ["GUILD_ADD"] = { enUS ="Guild Invite", zhCN = "公会邀请", zhTW = "公會邀請" },
    ["FRIEND_ADD"] = { enUS ="Add Friend",  zhCN = "添加好友", zhTW = "添加好友" },
}

for k, v in pairs(UnitPopupButtonsExtra) do
    v.text = v[T.client] or k
    UnitPopupButtons[k] = v
end

tinsert(UnitPopupMenus["FRIEND"], 1, "NAME_COPY")
tinsert(UnitPopupMenus["FRIEND"], 1, "SEND_WHO")
tinsert(UnitPopupMenus["FRIEND"], 1, "FRIEND_ADD")
tinsert(UnitPopupMenus["FRIEND"], 1, "GUILD_ADD")
tinsert(UnitPopupMenus["GUILD"], 1, "NAME_COPY")
tinsert(UnitPopupMenus["GUILD"], 1, "FRIEND_ADD")

hooksecurefunc("UnitPopup_OnClick", function(self)
    local unit = UIDROPDOWNMENU_INIT_MENU.unit
    local name = UIDROPDOWNMENU_INIT_MENU.name
    local server = UIDROPDOWNMENU_INIT_MENU.server
    local fullname = name
    local editBox
    if (server and (not unit or UnitRealmRelationship(unit) ~= LE_REALM_RELATION_SAME)) then
        fullname = name .. "-" .. server
    end
    if (self.value == "NAME_COPY") then
        editBox = ChatEdit_ChooseBoxForSend()
        local hasText = (editBox:GetText() ~= "")
        ChatEdit_ActivateChat(editBox)
        editBox:Insert(fullname)
        if (not hasText) then editBox:HighlightText() end
    elseif (self.value == "FRIEND_ADD") then
        C_FriendList.AddFriend(fullname)
    elseif (self.value == "SEND_WHO") then
        C_FriendList.SendWho("n-"..name)
    elseif (self.value == "GUILD_ADD") then
        GuildInvite(fullname)
    end
end)